"use strict";

// Import dependencies
import("/js/core.js").then(() =>
	import("/js/damper.js").then(() => {
		import("/js/telegram.js").then(() => {
			const dependencies = setInterval(() => {
				if (
					typeof core === "function" &&
					typeof core.damper === "function" &&
					typeof core.telegram === "function"
				) {
					clearInterval(dependencies);
					clearTimeout(timeout);
					initialization();
				}
			}, 10);
			const timeout = setTimeout(() => clearInterval(dependencies), 5000);

			function initialization() {
				const timer_for_response = setTimeout(() => {
					core.loading.setAttribute("disabled", true);

					const p = document.createElement("p");
					p.innerText = "Not authenticated";

					core.footer.appendChild(p);
				}, 3000);

				core.request(
					"/session/connect/telegram",
					"authentication=telegram&" + core.telegram.api.initData,
				)
					.then((json) => {
						if (
							json.errors !== null &&
							typeof json.errors === "object" &&
							json.errors.length > 0
						) {
							// Errors received
						} else {
							// Errors not received

							if (json.connected === true) {
								core.loading.setAttribute("disabled", true);

								clearTimeout(timer_for_response);
							}

							if (
								json.language !== null &&
								typeof json.language === "string" &&
								json.langiage.length === 2
							) {
								core.language = json.language;
							}
						}
					});
			}
		});
	})
);
