"use strict";

// Initialize of the class in global namespace
const core = class core {
	// Domain
	static domain = window.location.hostname;

	// Language
	static language = "ru";

	// Label for the "loding" element
	static loading = document.getElementById("loading");

	// Label for the <header> element
	static header = document.body.getElementsByTagName("header")[0];

	// Label for the <aside> element
	static aside = document.body.getElementsByTagName("aside")[0];

	// Label for the "menu" element
	static menu = document.body.querySelector("section[data-section='menu']");

	// Label for the <main> element
	static main = document.body.getElementsByTagName("main")[0];

	// Label for the <footer> element
	static footer = document.body.getElementsByTagName("footer")[0];

	/**
	 * Request
	 *
	 * @param {string} address
	 * @param {string} body
	 * @param {string} method POST, GET...
	 * @param {object} headers
	 * @param {string} type Format of response (json, text...)
	 *
	 * @return {Promise}
	 */
	static async request(
		address = "/",
		body,
		method = "POST",
		headers = {
			"Content-Type": "application/x-www-form-urlencoded",
		},
		type = "json",
	) {
		return await fetch(encodeURI(address), { method, headers, body })
			.then((response) => response[type]());
	}
};
